import Mock from 'mockjs'
import { pinyin } from 'pinyin-pro'

export function getData() {
    const data = Array(1000)
        .fill(0)
        .map(() => {
            const name = Mock.Random.cname()

            return {
                id: Mock.Random.guid(),
                name,
                phone: String(Mock.Random.integer(13000000000, 19999999999)),
                avatar: Mock.Random.image('50x50', Mock.Random.color(), '#757575', 'png', name.charAt(0)),
                unit: Mock.Random.cword(3, 5),
                checked: false,
            }
        })

    const result = data
        .map((item: any) => {
            const props = {}
            if (item.name) {
                item.letter = pinyin(item.name.charAt(), { pattern: 'first' })[0].toUpperCase()
            } else {
                item.letter = '★'
            }

            return {
                ...item,
                ...props,
                // TODO: 存在性能问题，需要优化后再使用
                // src: item.avatar || '/static/images/me/user_default.jpg',
                text: item.name,
                subText: item.unit,
            }
        })
        .reduce((prev: any, cur: any) => {
            const letter = cur.letter
            const index = prev.findIndex((item: any) => item.letter === letter)
            if (index === -1) {
                prev.push({
                    letter,
                    items: [cur],
                })
            } else {
                prev[index].items.push(cur)
            }
            return prev
        }, [])
        .sort((a: any, b: any) => {
            return a.letter.charCodeAt(0) - b.letter.charCodeAt(0)
        })

    return result
}
